<template>
  <div>
    <button-back />
    <goal-form :goal="goal" :process="create" />
  </div>
</template>

<script>
import ButtonBack from '~/components/buttons/Back'
import GoalForm from '~/components/goal/GoalForm'
import GoalModel from '~/models/Goal'
import labelMixin from '~/mixins/labelMixin'

export default {
  components: {
    ButtonBack,
    GoalForm
  },

  mixins: [
    labelMixin
  ],

  data () {
    const goal = new GoalModel()
    const parentId = this.$route.query.parent
    let parent = null
    if (parentId !== 0) {
      goal.parent = parentId
      parent = this.$store.getters['goals/getGoalById'](parentId)
    }

    goal.label = this.getChildLabel(parent)

    return {
      goal
    }
  },

  methods: {
    async create (goalModel) {
      if (goalModel.parent) {
        await this.$store.dispatch('goals/createSubGoal', goalModel)
        this.$router.go(-1)

        return
      }

      const goalId = await this.$store.dispatch('goals/createGoal', goalModel)
      this.$router.replace({ name: 'goals-id', params: { id: goalId } })
    }
  }
}
</script>
